﻿(function () {
    "use strict";

    var filename = "collection.urza";

    var saveFileLocally = function (file) {
        var data = JSON.stringify(UrzaGatherer.UserData);
        return Windows.Storage.FileIO.writeTextAsync(file, data);
    }

    var loadFileLocally = function (file) {
        Windows.Storage.FileIO.readTextAsync(file).then(function (data) {
            if (data) {
                UrzaGatherer.UserData = JSON.parse(data);
            }

            saveFile().then(function () {

                UrzaGatherer.UpdateCardsStatus();

                if (UrzaGatherer.Collection.onDataStatusChanged)
                    UrzaGatherer.Collection.onDataStatusChanged();
            });
        });
    }

    var saveFile = function () {
        return Windows.Storage.ApplicationData.current.localFolder.createFileAsync(filename, Windows.Storage.CreationCollisionOption.replaceExisting).then(function (file) {
            Windows.Storage.FileIO.writeTextAsync(file, JSON.stringify(UrzaGatherer.UserData));
        });
    }

    var init = function () {
        Windows.Storage.ApplicationData.current.localFolder.getFileAsync(filename).then(function (file) {
            // On success
            Windows.Storage.FileIO.readTextAsync(file).then(function (data) {
                if (data && data != "null")
                    UrzaGatherer.UserData = JSON.parse(data);
                else {
                    UrzaGatherer.UserData = {};
                }

                UrzaGatherer.UpdateCardsStatus();

                if (UrzaGatherer.Collection.onDataStatusChanged)
                    UrzaGatherer.Collection.onDataStatusChanged();
            });
        }, function () {
            // On error
            Windows.Storage.ApplicationData.current.localFolder.createFileAsync(filename, Windows.Storage.CreationCollisionOption.replaceExisting).then(function (file) {
                UrzaGatherer.UserData = {};
                Windows.Storage.FileIO.writeTextAsync(file, JSON.stringify(UrzaGatherer.UserData));

                if (UrzaGatherer.Collection.onDataStatusChanged)
                    UrzaGatherer.Collection.onDataStatusChanged();
            });
        });
    };

    WinJS.Namespace.define("UrzaGatherer.Collection", {
        Init: init,
        SaveFileLocally: saveFileLocally,
        LoadFileLocally: loadFileLocally,
        SaveFile: saveFile
    });
})();